<template>
	<f7-page 
		name="panic" 
		@page:beforein="onPageBeforeIn"
		ptr
		@ptr:refresh="onPageRefresh"
		>
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Tombol Panik">
            <f7-nav-title class="show-small-title">Jangan Panik</f7-nav-title>
		</f7-navbar>
		<f7-block v-if="panics.length > 0" style="text-align: justify;padding:20px;border-radius:7px;" class="no-margin gradient-cyan">
            <h3 class="no-margin">Penting!</h3>
            <p>Gunakan tombol panik ini dengan bijak, bukan untuk coba-coba. Edukasi anak-anak di bawah umur untuk menggunakannya <strong class="color-red">hanya dalam keadaan darurat saja</strong>. RingSatu tidak bertanggung jawab jika terjadi hal-hal yang mengganggu kenyamanan pihak-pihak terkait.</p>
        </f7-block>
		<f7-block class="menu-grid" v-if="panics.length > 0">
			<f7-row v-for="col in Math.ceil(panics.length / 2)" v-bind:key="col">
				<f7-col class="text-align-center" v-for="item in panics.slice((col - 1) * 2, col * 2)" v-bind:key="item.id">
					<f7-link class="display-block tap-hold" color="gray" :data-panic="JSON.stringify(item)">
						<img v-if="item.media != null" :src="item.media.url.small" width="64" class="img-circle">
						<img v-else :src="require('../assets/no-group-photo.png')" width="64" class="img-circle">
						<span class="text-uppercase color-black display-block margin-small-top margin-small-bottom">{{ item.name }}</span>
					</f7-link>
				</f7-col>
			</f7-row>
		</f7-block>
		<f7-block v-else style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="touch_app" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { initial, parseError } from '../js/utils';
export default {
	name: 'Panic',
	data(){
		return{}
	},
	computed: {
		...mapGetters('auth', ['user']),
		...mapGetters('panic', [
			'panics'
		]),
		currentLocation: function(){
			const self = this;

			let currentLocation = localStorage.getItem('currentLocation') ? JSON.parse(localStorage.getItem('currentLocation')) : null;
			return currentLocation;
		}
	},
	methods: {
		initial,
		getPanics(){
			const self = this;			

			self.$store.dispatch('panic/getPanics', {
				author: self.user.id,
				only: 'id,panic_group,name,description,media,actions.phone,actions.alt_phone,actions.action,actions.role.id,actions.role.name,actions.role.slug,author.id,author.phone,author.profile.fullname,author.profile.initial,author.profile.media,participants.id,participants.status,participants.user.id,participants.user.profile.fullname'
			});
		},
		onPageBeforeIn(){
			const self = this;
			const app = self.$f7;

			self.getPanics();
		},
		onPageRefresh(e, done){
			const self = this;
			const app = self.$f7;

            self.panicLoading = true;
            self.getPanics();
			done();	
		},
		doPanic(panic){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;		

			let live_mode = localStorage.getItem('live_mode');

			if(live_mode != null){
				app.dialog.confirm('Pengiriman sinyal tombol panik sedang berlangsung. Tekan tombol OK untuk menunggu respon/bantuan.', 'RingSatu', function(){					
					return false;
				}, function(){
					localStorage.removeItem('live_mode');
					return false;
				});
				return false;

			}else{
				
				app.preloader.show('green');

				self.$store.dispatch('panic/createPanicReport', {
					status: 'waiting',
					latitude: self.currentLocation.latitude,
					longitude: self.currentLocation.longitude,
					panic: parseInt(panic.id),
					reporter: self.user.id,
					residential: self.user.residential != null ? self.user.residential.id : null
				}).then((response) => {

					let panicreport = response.panicreport;

					if(panicreport.panic.live_location == true){
						// set panic expiration in 1 hour
						// and send data to database for live location tracking
						localStorage.setItem('live_mode', panicreport.panic.id+'|'+panicreport.live_expired);
					}

					app.preloader.hide();

					if('errors' in response){
						let error = parseError(response.errors);
						app.dialog.alert(error.messages, 'RingSatu');
						return false;
					}else{
						let buttons = [{
							text: panic.name,
							label: true
						}];

						for(const x of panic.actions){
							if(x.action == 'call'){
								buttons.push({
									text: 'Panggilan Telp 1',
									close: true,
									onClick: function(actions, e){
										location.href='tel://'+x.phone;
									}
								});

								if(x.alt_phone != ''){
									buttons.push({
										text: 'Panggilan Telp 2',
										close: true,
										onClick: function(actions, e){
											location.href='tel://'+x.alt_phone;
										}
									});
								}
							}
						}

						if(buttons.length > 1){
							let actionSheet = app.actions.create({
								buttons: buttons
							}).open();
						}else{
							app.dialog.alert('Sinyal tombol panik berhasil dikirimkan.', 'RingSatu');
						}
					}
					
				});
			}
		}
	},
	mounted(){
		const self = this;
		const app = self.$f7;
		const $$ = self.$$;

		$$(document).on('taphold', '.tap-hold', function(){

			let panic = JSON.parse($$(this).data('panic'));

			if(self.currentLocation != null){
				self.doPanic(panic);
			}else{
				app.dialog.alert('Gagal melakukan pengambilan data lokasi. Silahkan aktifkan fitur lokasi dari handphone anda.', 'RingSatu');
			}
		});
	},	
}
</script>
